;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; C64 Kernel routines header file for luna
; Includes list of user callable functions, and also a list of page 3
; vectors for overriding the kernel functions.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#ifndef _C64_KERNEL_H
#define _C64_KERNEL_H

;; User callable kernel routines.
;; This list is extracted from the C64 Programmers reference guide
#define k_acptr  $ffa5
#define k_chkin  $ffc6
#define k_chkout $ffc9
#define k_chrin  $ffcf
#define k_chrout $ffd2
#define k_ciout  $ffa8
#define k_cint   $ff81
#define k_clall  $ffe7
#define k_close  $ffc3
#define k_clrchn $ffcc
#define k_getin  $ffe4
#define k_iobase $fff3
#define k_ioinit $ff84
#define k_listen $ffb1
#define k_load   $ffd5
#define k_membot $ff9c
#define k_memtop $ff99
#define k_open   $ffc0
#define k_plot   $fff0
#define k_ramtas $ff87
#define k_rdtim  $ffde
#define k_readst $ffb7
#define k_restor $ff8a
#define k_save   $ffd8
#define k_scnkey $ff9f
#define k_screen $ffed
#define k_second $ff93
#define k_setlfs $ffba
#define k_setmsg $ff90
#define k_setnam $ffbd
#define k_settim $ffdb
#define k_settmo $ffa2
#define k_stop   $ffe1
#define k_talk   $ffb4
#define k_tksa   $ff96
#define k_udtim  $ffea
#define k_unlsn  $ffae
#define k_untlk  $ffab
#define k_vector $ff8d

;; Vectors for kernel routines
#define kv_irq $0314
#define kv_birq $0316
#define kv_nmi $0318
#define kv_open $031a
#define kv_close $031c
#define kv_chkin $031e
#define kv_ckout $0320
#define kv_clrch $0322
#define kv_basin $0324
#define kv_bsout $0326
#define kv_stop $0328
#define kv_getin $032a
#define kv_clall $032c
#define kv_usrcmd $032e
#define kv_load $0330
#define kv_save $0332

;; Vectors for BASIC are in c64/basic.h

#endif

