#ifndef _LIB6502_H
#define _LIB6502_H

#include <lunix/lunix.h>

#define E_NOFILE   $60
#define E_EOF      $61
#define E_EMPTY    $62
#define E_FULL     $63
#define E_NUL      $64
#define E_NOSEEK   $65
#define E_ILLPID   $66
#define E_NOTIMP   $67
#define E_NOSEM    $68
#define E_NOTFOUND $69

#define OWNTASK $0000

#define malloc    libc_malloc
#define mfree     libc_free
#define term      lk_suicide
#define vsem      lk_freeresource

;// macros that must be used instead of loading
;// immediate values
;//   "ldx #STDIN"  must be replaced by "ldx_stdin"

#define ldx_stdin  ldx  _base+1
#define ldx_stdout ldx  _base+2
#define ldx_stderr ldx  _base+3

;;/ not implemented features, that may return
;;/ E_NOTIMP (according to lib6502 V0.3 by Andre Fachat)

#define flock       _E_NOTIMP
#define fcntl       _E_NOTIMP
#define fgetattr    _E_NOTIMP
#define fsetattr    _E_NOTIMP

#define connect     _E_NOTIMP
#define listen      _E_NOTIMP
#define accept      _E_NOTIMP

#define forkthread  _E_NOTIMP
#define semget      _E_NOTIMP
#define semfre      _E_NOTIMP

#define signal      _E_NOTIMP

#define send        _E_NOTIMP
#define received    _E_NOTIMP

;;/ not implemented features, that will cause an error
;;/ because they can not simply return E_NOTIMP

;;/ fopen
;;/ fclose
;;/ fseek (always returnes E_NOSEEK)
;;/ pipe
;;/ fcmd
;;/ stddup
;;/ dup
;;/ fopendir
;;/ freaddir
;;/ fgetattr
;;/ fsetattr
;;/ chdir
;;/ exec
;;/ forkto
;;/ forkthread
;;/ sendsignal

#endif


