;;; LUnix header file for luna
;;;
;;; This file includes the addresses of all documented lunix functions
;;;    some other handy stuff.
;;; You should not need to include this as most functions can be indipentantly
;;;    found in other includes
;;;

	;; LUnix kenrel functions
#ifndef _LUNIX_LUNIX_H
#define _LUNIX_LUNIX_H 

; Create process run table
#define lk_makeprt $9000
; Declare process
#define lk_declproc $9003
; Send interrupt
#define lk_sendintr $9006
; Block process
#define lk_blockproc $9009
; Unblock process
#define lk_unblkproc $900f
; Break
#define lk_break     $9012
; Kill process 
#define lk_killproc  $9015
; Give up process (suicide)
#define lk_suicide $9018
; Suicide with error
#define lk_diewitherr $901b
; Unblock process (see lk_unblkproc)
#define lk_unblkproc2 $901e
; Memory Alloc
#define lk_memalloc $9030
; Memory free
#define lk_memfree $9033
; Page Alloc
#define lk_pagealloc $9036
; Less memory block
#define lk_lessmemblock $9039
; Get Exit code
#define lk_getexitcode $903c
; Initiate process
#define lk_initiateproc $9045
; Set sup byte
#define lk_setsupbyte $9048
; Call LUnix code relocator
#define lk_relocate $9051
; bas.StringOut
#define lk_basstrout $905d
; GetIPID
#define lk_getipid $9060
; PLoad
#define lk_pload $9063

#include <lunix/stdio.h>
#include <lunix/stdlib.h>

#endif
