#!/bin/bash

# set up include-path
export LUPO_INCLUDEPATH=../include

printf "Creating library...\n"
cd src

printf " assembler...\n"
for FILE in *.s
do
  printf "  \"${FILE}\" "
  luna -qOo ${FILE}o ${FILE} ; RESULT=$?
  if [ $RESULT = 0 ]; then
    printf "ok.\n"
  else
    ERROR="${ERROR} ${FILE}"
  fi
done
if [ ! "${ERROR}" = "" ]; then
  printf "had errors assembling: ${ERROR}\n"
  exit 1
fi

printf " linker...\n"
lld -Lo ../lib/stdlib.lib *.so ; RESULT=$?
if [ ! $RESULT = 0 ]; then
  printf "error while linking\n"
  exit 1
fi

rm *.so
cd ..

echo
exec maketest.sh
