		;; psem as described in the
		;; lib6502 standard library
		;; version 0.3 by A.Fachat

		;; psem
		;; < x=semaphore number
		;;   c=0:		don't block
		;;   c=1:		wait until gotten
		;; > c=0:		get semaphore
		;;   c=1:		a=error code

#include <lunix/lunix.h>
#include <lunix/kernel.h>
#include <lunix/semaphore.h>
#include <lib6502.h>

.global psem
psem:	bcs  noblock
		jsr  lk_lockresource
		bcs  illsem
		rts
		
noblock:
		sei
		tya
		lsr  a
		lsr  a
		lsr  a
		cmp  #4
		bcs  illsem
		tax
		tya
		and  #7
		tay
		lda  l_sembitmap,x
		and  l_revpowtab,y
		beq  psem				; go and lock it
		sec						; is already locked, so skip
illsem:			
		cli
		lda  #E_NOSEM
		rts

.endofcode