		;; tools to examine the commandline

#define _date (Jun 15 1997)
#include <lunix/lunix.h>
#include <luna.h>

		;; exported functions:
		
		.global read_comitem
		;; < -
		;; > c=0: A=$00: X=(char) option
		;;   c=0: A=$FF: X=(int)  pointer to argument (offset to _zpbase)
		;;   c=1: error (end of commandline)

		
		.data
		
compos:	.byte	1
mode:	.byte	0
arg:	.byte	0
quote:	.byte	0
squote:	.byte	0
argpos:	.byte	0

		.code

read_opt:
		tax
		iny
		bne		+
		dey
	  + sty		compos
		lda		#$00
		clc
		rts

skip:	sec
		rts
		
read_comitem:
		lda		_base+8
		beq		skip
		sta		_zpbase+1
		lda		#0
		sta		_zpbase
		ldy		compos
scan:	
		lda		(_zpbase),y
		beq		error
		cmp		#" "
		beq		swtonorm
		bit		mode
		bmi		read_opt
		cmp		#"-"
		beq		swtoopt

		;; read argument

 		sty		arg				; remember start of argument
		sty		argpos
		sty		compos

	  - ldy		compos
		lda		(_zpbase),y
		beq		end_arg
		cmp		#"\""
		beq		found_strquote
		cmp		#"\\"
		beq		found_quote
		cmp		#" "
		beq		found_space
cont1:	ldy		argpos			; (current char is part of arg-string)
		sta		(_zpbase),y
		inc		argpos
		ldx		#0				; (current char ends quote)
		stx		quote
cont2:	inc		compos
		bne		-
		beq		error			; (always jump)
		
swtonorm:
		lda		#$00
		beq		swtoopt+2
swtoopt:
		lda		#$ff
		sta		mode
		iny
		bne		scan
error:	sei
		lda		_base+8
		ldx		#0
		stx		_base+8
		jsr		lk_memfree
		cli
		sec
		rts

found_strquote:
		bit		quote
		bmi		cont1
		lda		#$ff
		eor		squote
		sta		squote
		bcs		cont2			; (always jump)

found_quote:
		bit		quote
		bmi		cont1
		lda		#$ff
		sta		quote
		bcs		cont2			; (always jump)

found_space:
		bit		quote
		bmi		cont1
		bit		squote
		bmi		cont1

		;; end of argument

		inc		compos
		beq		error
end_arg:						; compos points to NULL or next char
		ldy		argpos
		lda		#0
		sta		(_zpbase),y
		ldx		arg
		lda		#$ff
		clc
		rts
