		;; environment is global in the current
		;; version of LUnix (and limited to 256 bytes)
		
		;; $c26c (was unused) points to
		;; the page that holds the environment strings
		
#include <lunix/syszp.h>
#include <lunix/lunix.h>
#include <lunix/process.h>
#include <lunix/memory.h>
#include <luna.h>
		
.global setenv

		;; set/change environment string
		;; < (_zpbase)=pointer to zero terminated string
		;;       of format "variable=value"
		;; > c=error (if not enough space in environment page)

	-	cli
		
setenv:	sei
		jsr		unsetenv
		lda		l_environment
		bne		++

		;; environment not jet defined
		lda		#1
		ldx		#l_mo_environment
		jsr		lk_memalloc	   	; allocate one page
		bcc		+
		jsr		lk_lessmemblock	; out of memory, then wait and
		jmp		-				; try again

	+	sta		l_environment
		sta		_hl+1			; create empty environment
		ldy		#0
		sty		_hl
		lda		#1
		sta		(_hl),y
		sta		_hl
		bne		++				; (always jump)

		;; (try to) add string to environment

	+	sta		_hl+1			; IRQ is disabled so usage of _hl/_hl+1 is
		ldy		#0				; legal
		sty		_hl
		lda		(_hl),y
		sta		_hl
		
	+ -	lda		(_zpbase),y		; copy string into environment page
		sta		(_hl),y
		beq		+
		iny
		bne		-
	-	sec						; not enough space in environment!
		lda		#0
		tay
		sta		(_hl),y
		cli
		rts

	+	iny						; add zero to terminate list
		beq		-
		sta		(_hl),y
		clc
		tya						; set new length of list
		adc		_hl
		ldy		#0
		sty		_hl
		sta		(_hl),y
		clc
		cli
		rts


