		;; simple readline

#include <luna.h>
#include <lunix/lunix.h>
#include <lunix/stdio.h>

.global sreadline
		;; sreadline
		;; 
		;;  < _zpbase=pointer to buffer
		;;    Y=length of buffer (up to 255 chars)
		;; 
		;;  > c=1 :	A=0 EOF
		;;          A>0 I/O error
		;;    c=0 :	Y=length of line (MUST be >0!)
				
	-	cmp  #160
		bcc  +					; ignore all in range 128...159
		jmp  ++
		
sreadline:
		dey
		sty  len_limit
		ldy  #0

	- +	jsr  lk_stdin
		bcs  io_error
		bmi  --
		cmp  #4
		beq  io_eof
		cmp  #13
		beq  _eol
		cmp  #20
		beq  _backspc
		cmp  #32
		bcc  -					; ignore all <32
	+	cpy  len_limit
		beq  -					; skip if buffer is already filled up
		jsr  lk_stdout
		sta  (_zpbase),y
		iny
		bne  -

_eol:	lda  #0
		sta  (_zpbase),y
		lda  #13
		jsr  lk_stdout
		bcs  io_error
		rts

_backspc:
		tya
		beq  -					; ignore backspaces, when len=0
		lda  #157				; step left
		jsr  lk_stdout
		lda  #32				; print space (rease char)
		jsr  lk_stdout
		lda  #157
		jsr  lk_stdout			; another step to the left
		dey
		jmp  -
		
io_eof:	tya
		bne  -
		lda  #$00
		sec
		rts
		
io_error:
		lda  #$ff	
		rts

.eodofcode
len_limit:		.buf 1
