		;; simple testprogramm
		;; for libc_malloc/free/remalloc

#include <cstyle.h>
#include <luna.h>
#include <lunix/system.h>

		;; you MUST allocate at least 4 zeropage bytes, if
		;; you want to use libc-malloc!
		
.header "amalloc", .tmp1, .tmp2

	-	lda  #0
		jmp  suicide
		
_init:	print_string("Welcome to tmalloc\n")

main_loop:
		lda  cmem_start+1
		jsr  print_hex8
		lda  cmem_start
		jsr  print_hex8
		jsr  print_prompt
		lea_xa(line_buffer)
		stx  tmp1
		sta  tmp1+1
		ldy  #10
		jsr  sreadline
		bcs  -
		lea_xa(line_buffer)
		sta  tmp1+1
		stx  tmp1
		ldy  #0
		jsr  eat_white_spaces
		beq  main_loop			; (empty line)
		cmp  #"m"
		beq	 do_malloc
		;; cmp  #"r"
		;; beq  do_remalloc
		cmp  #"f"
		beq  do_free
		print_string("unknown command\n")
		jmp  main_loop


do_malloc:
		iny
		jsr  read_hex16
		lda	 tmp2
		ldy  tmp2+1
		jsr  libc_malloc
		sta  tmp2
		sty  tmp2+1
		print_string("malloc: ")
		lda  tmp2+1
		jsr  print_hex8
		lda  tmp2
		jsr  print_hex8
		lda  #13
		jsr  putc
		jmp  main_loop
		
do_free:	
		iny	
		jsr  read_hex16
		lda  tmp2
		ldy  tmp2+1
		jsr  libc_free
		print_string("free.\n")
		jmp  main_loop

eat_white_spaces:
		lda  (tmp1),y
		beq  +
		cmp  #" "
		bne  +
		iny
		bne  eat_white_spaces
	+	rts
		
read_hex16:
		ldx  #0
		stx  tmp2
		stx  tmp2+1
		jsr  eat_white_spaces
		beq  +
	-	jsr  conv_hexdigit
		bcs  +
		inx
		pha
		lda  tmp2+1
		asl  tmp2
		rol  a
		asl  tmp2
		rol  a
		asl  tmp2
		rol  a
		asl  tmp2
		rol  a
		sta  tmp2+1
		pla
		ora  tmp2
		sta  tmp2
		iny
		beq  +
		lda  tmp2+1
		and  #$f0
		bne  +
		lda  (tmp1),y
		bne  -
	+	rts								

conv_hexdigit:
		sec
		and  #$7f
		sbc  #"0"
		bcc  ++
		cmp  #10
		bcc  +
		sbc  #7
		cmp  #10
		bcc  ++
		cmp  #16
		bcs  ++
	+	rts
	+	sec
		rts

print_prompt:	
		lda  #">"
		jsr  putc
		lda  #" "
		jmp  putc
						
.eodofcode
line_buffer:	.buf 256
